(*
 * Copyright 2005, 2006, 2007 Aaron R. Bradley and Zohar Manna
 *
 * This file is part of PiVC.
 * 
 * PiVC is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 3 of the License, or (at your
 * option) any later version.
 * 
 * PiVC is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *)

module L = List

open Vcg

let valid prgm fn e =
  Arrays.valid prgm fn e

let smt_of prgm fn e =
  Arrays.smt_of prgm fn e

let split e =
  let rec split = function
    | BExpr e -> L.map (fun e -> BExpr e) (split e)
    | And (e1, e2) -> (split e1) @ (split e2)
    | Or (Not e1, e2) -> L.map (fun e -> Or (Not e1, e)) (split e2)
    | Forall (t, v, e) -> L.map (fun e -> Forall (t, v, e)) (split e)
    | x -> [x]
  in
  split e
