(*
 * Copyright 2005, 2006, 2007 Aaron R. Bradley and Zohar Manna
 *
 * This file is part of PiVC.
 * 
 * PiVC is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 3 of the License, or (at your
 * option) any later version.
 * 
 * PiVC is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *)

module E = Expr
module P = Program
module T = Type

module L = List

let interp = ref []

let interpreted pnm =
  L.exists (fun (_, pnm', _) -> pnm = pnm') !interp

let declare typ nm params =
  interp := (typ, nm, params) :: !interp

let register prgm = 
  P.interp_source interpreted;
  L.iter
    (fun (rtyp, fnm, params) ->
      P.declare_fn prgm E.const_true E.const_true rtyp fnm params;
      let x = E.Var "x" in
      let blk = Cfg.blk [(rtyp, "x")] (Cfg.return_stmt (Some x)) in
      (* preserve Global's save stack *)
      Global.save (); Global.save ();
      P.declare_fn_impl prgm fnm blk)
    !interp

