(*
 * Copyright 2005, 2006, 2007 Aaron R. Bradley and Zohar Manna
 *
 * This file is part of PiVC.
 * 
 * PiVC is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 3 of the License, or (at your
 * option) any later version.
 * 
 * PiVC is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *)

type typ =
  | Int
  | Float
  | Bool
  | Alias of string
  | UIT of string
  | Struct of string * (typ * string) list
  | Array of typ


module TSet : Set.S with type elt = typ


val string_of_typ : typ -> string
val step_string_of_typ : typ -> string

val short_string_of_typ : typ -> string


val typ : string -> typ

val struct_typ : string -> (typ * string) list -> typ

val array_typ : typ -> typ


val expand : typ -> typ

val is_array : typ -> bool


val equal_typ : typ -> typ -> bool


val alias_source : (string -> typ option) -> unit
